C                 	DAT2RIT   (A. Le Bail)
C            is a program for tranforming powder data files
C            such as .dat obtained from the CVRAW program 
C            applied on Siemens .raw files.
C                The starting .dat must be :
C                        TITLE
C                        N of points
C                        2-theta starting angle
C                        Step in 2-theta
C                        Intensities, one per line in free format
C                        .............
C
C                The output will be a .rit file in DBW Format
C                readable by DMPLOT :
C                2-theta-zero, step, 2-theta-end, TITLE   as 3F8,A56
C                Intensities                              as 8(F7,1X)
C
C        The program creates also a .uxd file with data as I9,7I10
C   
C
      character*20 file
      character*24 tmp
      logical qex
      DIMENSION  Y(40000),TITLE(56),T2(40000),IY(40000),YY(40000)
      DIMENSION  Y2(40000)
      IPL=19
      IPR=20
      ILU=21
      print 3
    3 FORMAT('         DAT2RIT   (by A. Le Bail)'/
     &'      is a program for tranforming powder data files'/
     &'      such as .dat obtained from the CVRAW program'/
     &'      applied on Siemens .raw files.'/
     &'         The starting .dat must be :'/
     &'                 TITLE'/
     &'                 N of points'/
     &'                 2-theta starting angle'/
     &'                 Step in 2-theta'/
     &'                 Intensities, in free format'/
     &'                                                   '/
     &'         The output will be a .rit file in DBW Format'/
     &'         readable by DMPLOT :'/
     &'         2-theta-zero, step, 2-theta-end, TITLE   as 3F8.3,56A1'/
     &'         Intensities                              as 8(F7.0,1X)'//
     &'         and also a .uxd file will be created'/)
      C1=1.
      C2=1.
      C3=1.
      DO 771 I=1,40000
771   YY(I)=0.
770   print 1
1     format('  entry .dat file (no extension) ??',$)
      read 2,file
2     format(A20)
4     format(A24)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
      tmp=file(1:lfile)//'.dat'
      call open_read1(ilu,tmp)
      tmp=file(1:lfile)//'.rit'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.) go to 10
      print *,'warning, this old file will be deleted :',tmp
      call filedel(ipr,tmp)
10    call open_write1(ipr,tmp)
      tmp=file(1:lfile)//'.uxd'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.) go to 11
      print *,'warning, this old file will be deleted :',tmp
      call filedel(ipl,tmp)
11    call open_write1(ipl,tmp)
      print 20
20    format('  Daresbury (1) or Siemens (2) or XY (3) ??',$)
      read *,ntyp
	if(ntyp.gt.1)go to 50
C10 minute run.  Lambda = 0.48680 Angstrom
C 2-theta  d-spacing  ???       Counts
C  0.058   0.00000    0.0131    1382
C  0.087   0.00000    0.0196    1133
      READ(ILU,21)(TITLE(I),I=1,56)
21    FORMAT(56A1/)
      K=1
22	READ(ILU,*,ERR=30)T2(K),A1,A2,Y(K)
      K=K+1
	GO TO 22
30    NBMES=K-1
      TH0=T2(1)
	STP=T2(2)-T2(1)
	THF=T2(NBMES)
      go to 60
50    READ(ILU,5)(TITLE(I),I=1,56)
5     FORMAT(56A1)
      READ(ILU,*)NBMES
      READ(ILU,*)TH0
      READ(ILU,*)STP
      TH0=TH0+STP/2.
      X1=TH0
      DO 7604 I=1,NBMES
      THF=X1
      IY(I)=Y(I)
7604  X1=X1+STP
      IF(NTYP.EQ.3) GO TO 750
      READ(ILU,*)(Y(I),I=1,NBMES)
      GO TO 60
750   DO 751 I=1,NBMES
751   READ(ILU,*)A1,Y(I)
60    continue
      CLOSE(21)
      DO 773 I=1,NBMES
773   YY(I)=(YY(I)*C1+Y(I)*C2)/C3
      PRINT 25
25    format('  Add another pattern ? YES=1, NO=0',$)
      READ *,NADD
      IF(NADD.EQ.0)GO TO 27
      PRINT 26
26    format('  Y=(Y1*C1+Y2*C2)/C3  C1, C2, C3 ?',$)
      READ *,C1,C2,C3
      IF(NADD.EQ.1)GO TO 770
      PRINT 26
27    DO 752 I=1,NBMES
      Y(I)=YY(I)
752   IY(I)=Y(I)
      WRITE(IPL,703)TH0,STP,THF,(TITLE(I),I=1,56)
703	FORMAT(3F8.3,1X,56A1)
      PRINT 300
300   FORMAT('  Add a constant to the intensity (No=1, Yes=0)?',$)
      READ *,NADD
      IF(NADD.EQ.1)GO TO 2060
	PRINT 31
31    FORMAT('  Value of this constant ?',$)
      READ *,ADD
      DO 2050 I=1,NBMES
      Y(I)=Y(I)+ADD
2050  IY(I)=Y(I)
2060  PRINT 301
301   FORMAT('  Change the step and interpolate (No=1, Yes=0) ?',$)
      read *,NINT
      IF(NINT.EQ.1)GO TO 302
      PRINT 303
303   FORMAT('  New step ?',$)
      read *,DQ
      CALL INTERP(NBMES,TH0,STP,DQ,Y,Y2)
      STP=DQ
      DO 304 I=1,NBMES
      IY(I)=Y2(I)
304   Y(I)=Y2(I)
302   PRINT 200
200   FORMAT('  Sum N points in one ? Yes=N, No=0',$)
      READ *,NTWO
      IF(NTWO.EQ.0)GO TO 210
      DO 201 I=1,NBMES
201   T2(I)=Y(I)
      T2(NBMES+1)=Y(NBMES)
      J=1
      DO 202 I=1,NBMES,NTWO
	T2(J)=0.
	DO 230 K=1,NTWO
230   T2(J)=T2(J)+Y(I+K-1)
202   J=J+1
      NBMES=J-1
	XM=NTWO
      STP=STP*XM
      X1=TH0
      DO 203 I=1,NBMES
      Y(I)=T2(I)
      IY(I)=T2(I)
      THF=X1
203   X1=X1+STP
210	WRITE(IPR,703)TH0,STP,THF,(TITLE(I),I=1,56)
      DO 2300 I=1,NBMES,8
2300	WRITE(IPR,704)Y(I),Y(I+1),Y(I+2),Y(I+3),Y(I+4),Y(I+5),
     1Y(I+6),Y(I+7)
704	FORMAT(8(F7.0,1X))
      DO 2400 I=1,NBMES,8
2400	WRITE(IPL,705)IY(I),IY(I+1),IY(I+2),IY(I+3),IY(I+4),
     1IY(I+5),IY(I+6),IY(I+7)
705	FORMAT(I9,7I10)
      PRINT 6
   6  FORMAT('   Thanks for using DAT2RIT'/
     &'     Care to rounding errors on 2-theta-end...'/
     &'   Please type any number and a return to stop')
      Read *,bid
      STOP
      END
C
C  
C
      SUBROUTINE INTERP(M,T0,PAS,DQ,Y1,Y2)
	DIMENSION Y1(40000),X1(40000),Y2(40000),X2(40000)
	DIMENSION IR(20),R(20)
	T=T0
	DO 7000 I=1,M
	X1(I)=T
7000	T=T+PAS
	J=1
      Y2(1)=Y1(1)
	DO 4 I=2,40000
	Y2(I)=0.
	X2(I)=T0+DQ*(I-1.)
	IF(X2(I).LT.X1(1).OR.X2(I).GE.X1(M)) GO TO 4
6	IF(X2(I).GE.X1(J).AND.X2(I).LT.X1(J+1)) GO TO 7
	J=J+1
	GO TO 6
7	Y2(I)=(X2(I)-X1(J))/(X1(J+1)-X1(J))*Y1(J+1)
	Y2(I)=Y2(I)+(X1(J+1)-X2(I))/(X1(J+1)-X1(J))*Y1(J)
4	CONTINUE
	I=40000
5	IF(Y2(I).NE.0.) GO TO 8
	I=I-1
	GO TO 5
8	M=I
      RETURN
	END
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close (unit,status='delete')
      return
      end
